(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('angular-ng-autocomplete')) :
    typeof define === 'function' && define.amd ? define('angular-google-autocomplete', ['exports', '@angular/core', 'angular-ng-autocomplete'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['angular-google-autocomplete'] = {}, global.ng.core, global.i1));
}(this, (function (exports, i0, i1) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);

    var GoogleService = /** @class */ (function () {
        function GoogleService() {
            var _this = this;
            this.arr = [];
            this.autoCompleteService = function () {
                return new Promise(function (resolve, reject) {
                    _this.autocompleteService = new google.maps.places.AutocompleteService();
                    if (_this.autocompleteService !== undefined && _this.autocompleteService !== null) {
                        resolve(_this.autocompleteService);
                    }
                    else {
                        reject('AutoComplete Serice failed.');
                    }
                });
            };
            this.placesService = function () {
                return new Promise(function (resolve, reject) {
                    _this.placesSrv = new google.maps.places.PlacesService(document.createElement("div"));
                    if (_this.placesSrv !== undefined && _this.placesSrv !== null) {
                        resolve(_this.placesSrv);
                    }
                    else {
                        reject('Places Serice failed.');
                    }
                });
            };
            this.setCurrentPosition = function () {
                return new Promise(function (resolve, reject) {
                    if ('geolocation' in navigator) {
                        navigator.geolocation.getCurrentPosition(function (position) {
                            if (position !== undefined) {
                                resolve(position);
                            }
                            else {
                                reject('Failed to get current position.');
                            }
                        });
                    }
                });
            };
            this.getQueryPredictions = function (searchQuery) {
                return new Promise(function (resolve, reject) {
                    var request = {
                        input: searchQuery,
                        componentRestrictions: { country: 'no' },
                        types: ['(address)']
                    };
                    _this.autocompleteService.getQueryPredictions(request, function (predictions, status) {
                        if (status !== google.maps.places.PlacesServiceStatus.OK || !predictions) {
                            reject(status);
                        }
                        else {
                            if (predictions.length > 0) {
                                resolve(predictions);
                            }
                        }
                    });
                });
            };
            this.getMyLocation = function (latitude, longitude) {
                return new Promise(function (resolve, reject) {
                    var myLocation = new google.maps.LatLng(latitude, longitude);
                    var geocoder = new google.maps.Geocoder();
                    geocoder.geocode({ 'latLng': myLocation }, function (results, status) {
                        if (status !== google.maps.places.PlacesServiceStatus.OK || !results) {
                            reject(status);
                        }
                        else {
                            if (results.length > 0) {
                                resolve(results);
                            }
                        }
                    });
                });
            };
            if (!this.isGoogleLibExists()) {
                throw new Error('Google maps library can not be found');
            }
        }
        GoogleService.prototype.isGoogleLibExists = function () {
            return !(!google || !google.maps || !google.maps.places);
        };
        return GoogleService;
    }());
    GoogleService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: GoogleService, deps: [], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    GoogleService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: GoogleService, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: GoogleService, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root'
                    }]
            }], ctorParameters: function () { return []; } });

    var AngularGoogleAutocompleteComponent = /** @class */ (function () {
        function AngularGoogleAutocompleteComponent() {
            var _this = this;
            this.autocompleteResults = [];
            this.currentPoslatitude = 0;
            this.currentPoslongitude = 0;
            this.latitude = 0;
            this.longitude = 0;
            this.selectedPlace = new i0.EventEmitter();
            this.keyword = 'description';
            this.data = [
                {
                    id: 1,
                    name: 'Usa'
                },
                {
                    id: 2,
                    name: 'England'
                }
            ];
            this.searchPlaces = function (textQuery) {
                _this.googleService.getQueryPredictions(textQuery).then(function (predictions) {
                    if (predictions !== undefined && predictions !== null) {
                        _this.autocompleteResults = predictions;
                    }
                });
            };
            this.googleService = new GoogleService();
        }
        AngularGoogleAutocompleteComponent.prototype.ngOnInit = function () {
            this.initialize();
        };
        AngularGoogleAutocompleteComponent.prototype.initialize = function () {
            var _this = this;
            this.googleService.autoCompleteService().then(function (autocompService) {
                _this.autocompleteService = autocompService;
            });
            this.googleService.placesService().then(function (plcService) {
                _this.placesService = plcService;
            });
        };
        AngularGoogleAutocompleteComponent.prototype.selectEvent = function (item) {
            // do something with selected item
            console.log(item);
            this.selectedPlace.emit(item);
        };
        AngularGoogleAutocompleteComponent.prototype.onChangeSearch = function (textQuery) {
            if (textQuery !== undefined && textQuery !== null && textQuery !== "") {
                this.searchPlaces(textQuery);
            }
        };
        AngularGoogleAutocompleteComponent.prototype.onFocused = function (e) {
            // do something when input is focused
            console.log(e);
        };
        return AngularGoogleAutocompleteComponent;
    }());
    AngularGoogleAutocompleteComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: AngularGoogleAutocompleteComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    AngularGoogleAutocompleteComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.0.1", type: AngularGoogleAutocompleteComponent, selector: "angular-google-autocomplete", outputs: { selectedPlace: "selectedPlace" }, ngImport: i0__namespace, template: "<div class=\"ng-autocomplete\">\r\n      <ng-autocomplete\r\n        [data]=\"autocompleteResults\"\r\n        [searchKeyword]=\"keyword\"\r\n        (selected)='selectEvent($event)'\r\n        (inputChanged)='onChangeSearch($event)'\r\n        (inputFocused)='onFocused($event)'\r\n        [itemTemplate]=\"itemTemplate\"\r\n        [notFoundTemplate]=\"notFoundTemplate\"\r\n        placeholder=\"Adresse, Ole Brums vei 1\">\r\n      </ng-autocomplete>\r\n\r\n      <ng-template #itemTemplate let-item>\r\n        <ul class=\"list-group\">\r\n          <li class=\"list-group-item d-flex align-items-left\">\r\n            <div class=\"image-parent divIcon\">\r\n              <i class=\"fa fa-map-marker\"></i>\r\n            </div>\r\n            <div style=\"float: left;\">\r\n              <a [innerHTML]=\"item.description\"></a>\r\n            </div>\r\n          </li>\r\n        </ul>\r\n      </ng-template>\r\n\r\n      <ng-template #notFoundTemplate let-notFound>\r\n        <div [innerHTML]=\"notFound\"></div>\r\n      </ng-template>\r\n  </div>\r\n", styles: [".divIcon{margin-right:5px;width:10px;margin-top:13px;margin-left:10px}.ng-autocomplete{max-width:100%;width:100%}"], components: [{ type: i1__namespace.AutocompleteComponent, selector: "ng-autocomplete", inputs: ["data", "placeholder", "heading", "historyHeading", "historyListMaxNumber", "notFoundText", "minQueryLength", "focusFirst", "disabled", "searchKeyword", "initialValue", "historyIdentifier", "isLoading", "debounceTime", "customFilter", "itemTemplate", "notFoundTemplate"], outputs: ["selected", "inputChanged", "inputFocused", "inputCleared", "opened", "closed", "scrolledToEnd"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: AngularGoogleAutocompleteComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'angular-google-autocomplete',
                        templateUrl: "./angular-google-autocomplete.component.html",
                        styleUrls: ["./angular-google-autocomplete.component.css"]
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { selectedPlace: [{
                    type: i0.Output
                }] } });

    var AngularGoogleAutocompleteModule = /** @class */ (function () {
        function AngularGoogleAutocompleteModule() {
        }
        return AngularGoogleAutocompleteModule;
    }());
    AngularGoogleAutocompleteModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: AngularGoogleAutocompleteModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    AngularGoogleAutocompleteModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: AngularGoogleAutocompleteModule, declarations: [AngularGoogleAutocompleteComponent], imports: [i1.AutocompleteLibModule], exports: [AngularGoogleAutocompleteComponent] });
    AngularGoogleAutocompleteModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: AngularGoogleAutocompleteModule, imports: [[
                i1.AutocompleteLibModule
            ]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: AngularGoogleAutocompleteModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            AngularGoogleAutocompleteComponent
                        ],
                        imports: [
                            i1.AutocompleteLibModule
                        ],
                        exports: [
                            AngularGoogleAutocompleteComponent
                        ]
                    }]
            }] });

    /*
     * Public API Surface of angular-google-autocomplete
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AngularGoogleAutocompleteComponent = AngularGoogleAutocompleteComponent;
    exports.AngularGoogleAutocompleteModule = AngularGoogleAutocompleteModule;
    exports.GoogleService = GoogleService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angular-google-autocomplete.umd.js.map
